package AmazonItem;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（Amazon商品リンク）
# AmazonItem.pm 1.0.3
# Copyright (C) 2007-2014 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-07-01
######################################################################
$AmazonItem::end_point = 'webservices.amazon.co.jp';
$AmazonItem::uri = '/onca/xml';
$AmazonItem::aws_version = '2013-08-01';
@AmazonItem::search_index = (
	'Blended'			=>	'すべてのカテゴリー',
	'KindleStore'		=>	'Kindleストア ',
#	'instant-video'		=>	'Amazon インスタント・ビデオ',
	'MP3Downloads'		=>	'デジタルミュージック',
#	'mobile-apps'		=>	'Androidアプリ',
	'Books'				=>	'本',
	'ForeignBooks'		=>	'洋書',
	'Music'				=>	'ミュージック',
	'MusicTracks'		=>	'曲名から調べる',
	'Classical'			=>	'クラシック',
	'DVD'				=>	'DVD',
	'VideoGames'		=>	'TVゲーム',
	'Software'			=>	'PCソフト',
#	'computers'			=>	'パソコン・周辺機器',
	'Electronics'		=>	'家電&amp;カメラ',
	'OfficeProducts'	=>	'文房具・オフィス用品',
	'Kitchen'			=>	'ホーム&amp;キッチン',
#	'Pets'				=>	'ペット用品',
	'HealthPersonalCare'	=>	'ヘルス&amp;ビューティー',
	'Beauty'			=>	'コスメ',
	'Grocery'			=>	'食品&amp;飲料',
	'Baby'				=>	'ベビー&amp;マタニティ',
	'Apparel'			=>	'服＆ファッション小物',
	'Shoes'				=>	'シューズ＆バッグ',
	'Watches'			=>	'腕時計',
	'Jewelry'			=>	'ジュエリー',
	'Toys'				=>	'おもちゃ',
	'Hobbies'			=>	'ホビー',
	'MusicalInstruments'	=>	'楽器',
	'SportingGoods'		=>	'スポーツ&amp;アウトドア',
	'Automotive'		=>	'カー・バイク用品',
	'HomeImprovement'	=>	'DIY・工具',
	'Appliances'		=>	'大型家電',
#	'financial'			=>	'クレジットカード'
);

$AmazonItem::no_image_gif_large = 'http://ec1.images-amazon.com/images/G/09/nav2/dp/no-image-no-ciu.gif';
$AmazonItem::no_image_gif_large_width = 192;
$AmazonItem::no_image_gif_large_height = 192;
$AmazonItem::no_image_gif_small = 'http://ec1.images-amazon.com/images/G/09/icons/books/comingsoon_books.gif';
$AmazonItem::no_image_gif_small_width = 60;
$AmazonItem::no_image_gif_small_height = 40;
######################################################################
sub amazon_api_url ($$) {
my($this,$hash_ref) = @_;
my %queries = (
	'Service'			=>	'AWSECommerceService',
	'AWSAccessKeyId'	=>	$env::amazon_access_key,
	'Version'			=>	$AmazonItem::aws_version,
	'ResponseGroup'		=>	'Small,ItemAttributes,Images',
);
$queries{'AssociateTag'} = $this->{'associatesId'} if $this->{'associatesId'};
if (ref $hash_ref) {
	while (my($k,$v) = each %$hash_ref) {
		$queries{$k} = $v;
	}
}
$queries{'Timestamp'} = $this->amazon_time_stamp if $env::amazon_secret_access_key;
my $query = '';
foreach my $k (sort keys %queries) {
	$query .= '&' . $this->amazon_url_encode($k) . '=' . $this->amazon_url_encode($queries{$k});
}
$query =~ s/^&//;
return 'http://' . $AmazonItem::end_point . $AmazonItem::uri . '?' . $query . (($env::amazon_secret_access_key) ? '&Signature=' . $this->amazon_url_encode($this->amazon_signature($query)) : '');
}

sub amazon_time_stamp ($) {
my $this = shift;
my @gmt = gmtime(time);
return sprintf("%04d-%02d-%02dT%02d:%02d:%02d.000Z",$gmt[5]+1900,$gmt[4]+1,$gmt[3],$gmt[2],$gmt[1],$gmt[0]);
}

sub amazon_signature ($$) {
my($this,$query) = @_;
if (eval 'use Digest;use Digest::SHA qw(hmac_sha256_base64);1;' || eval 'use Digest::SHA::PurePerl qw(hmac_sha256_base64);1;') {
	return hmac_sha256_base64(
		"POST\n" . $AmazonItem::end_point . "\n" . $AmazonItem::uri. "\n" . $query,
		$env::amazon_secret_access_key
	) . '=';
} else {
	return '';
}
}

sub amazon_url_encode ($$) {
my($this,$text) = @_;
return '' if !defined $text || $text eq '';
utf8::encode($text) if utf8::is_utf8($text);
$text =~ s/([\x00-\x29\x2B\x2C\x2F\x3A-\x3F\x5B-\x5E\x60\x7B-\xFF])/'%' . sprintf("%.2X", unpack("C", $1))/eg;
return $text;
}

######################################################################
sub _set ($$) {
my($this,$setting) = @_;
$this->{'associatesId'} = $env::amazon_associates_id if !$this->{'associatesId'} && $env::amazon_associates_id;
$this->{'openNewWindow'} = 1 if !defined $this->{'openNewWindow'};
$this->{'refererCheck'} = 1 if !defined $this->{'refererCheck'};
$this->{'image'} = 'medium' if !defined $this->{'image'};

#複数の要素を登録
$this->{'elements'} = 1;
return;
}

######################################################################
#	(2) obj->form;
sub form {
my($this,$status) = @_;
my($name,$form);

#名前にデータIDを埋め込む
$name = 'data:' . $this->{'id'} . ':asin';

#フィールドネーム+ヘッダ
$form = $this->field_header;
$form .= '<label for="' . $name . '" class="datatitle">ASIN</label>';
$form .= ' <input type="text" name="' . $name . '" id="' . $name . '" size="12" value="' . $this->escape($main::data{$this->{'id'}}{'asin'}) . '"' . (($this->{'is_invalid_field'}{'asin'}) ? $this->set_invalid_class : '') . ' />';
$form .= ' <a href="./start.cgi' . $this->escape($this->get_query_for_editor) . '" target="amazonViewer" class="note" onclick="cmonos.window.open(\'amazonViewer\',640,600)">検索ウィンドウを開く</a>';
$form .= '<div id="amazon-sample-' . $this->{'id'} . '">';
$form .= $this->amazon_link($main::data{$this->{'id'}}) if ref $main::data{$this->{'id'}};
$form .= '</div>';
$form .= $this->field_footer;
return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
my $this = shift;
delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
my $is_valid = $this->is_not_empty('asin');
if ($is_valid && defined $main::data{$this->{'id'}}{'asin'} && $main::data{$this->{'id'}}{'asin'} ne '') {
	$main::data{$this->{'id'}}{'asin'} = $this->z_to_h($main::data{$this->{'id'}}{'asin'});#半角変換
	if ($main::data{$this->{'id'}}{'asin'} =~ /[^0-9a-zA-Z_]/) {
		$main::data{$this->{'id'}}{'asin'} = '';
		push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : '入力') . 'が ASIN ではありません。') if ref $cgi::action;
		$is_valid = 0;
	} else {
		require CMONOS::CGI_Lib::HTTP_Client;
		my $res = HTTP_Client->new->request('POST' => $this->amazon_api_url({'Operation' => 'ItemLookup','ItemId' => $main::data{$this->{'id'}}{'asin'}}));
		if ($res->is_success) {
			my $hash = $res->hash('utf8');
			if ($hash->{'ItemLookupResponse'}->{'Items'}->{'Request'}->{'Errors'}) {
				if (ref $cgi::action) {
					$this->scalar_to_array(\$hash->{'ItemLookupResponse'}->{'Items'}->{'Request'}->{'Errors'}->{'Error'});
					foreach my $error (@{$hash->{'ItemLookupResponse'}->{'Items'}->{'Request'}->{'Errors'}->{'Error'}}) {
						push(@{$cgi::action->{'dialog'}},$error->{'Message'}) if $error->{'Message'};
					}
				}
				push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : '入力') . '(ASIN)に該当する商品が存在しません。') if ref $cgi::action;
				$is_valid = 0;
			} elsif ($hash->{'ItemLookupResponse'}->{'Items'}->{'Item'} && ref $hash->{'ItemLookupResponse'}->{'Items'}->{'Item'} eq 'HASH') {
				my $item = $hash->{'ItemLookupResponse'}->{'Items'}->{'Item'};
				$main::data{$this->{'id'}} = {};
				$this->set_item_data($main::data{$this->{'id'}},$item);
				$this->data;
			} else {
				$is_valid = 0;
				push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : '入力') . 'を正常に処理できませんでした。Amazon からの応答が予期されたものではありません。') if ref $cgi::action;
			}
		} else {
			$is_valid = 0;
			push(@{$cgi::action->{'dialog'}},(($this->{'name'}) ? $this->{'name'} : '入力') . 'を正常に処理できませんでした。Amazon に接続できませんでした。') if ref $cgi::action;
		}
	}
}
$this->{'is_invalid_field'}{'asin'} = 1 if !$is_valid;
return $is_valid;
}

sub set_item_data {
my($this,$data,$item) = @_;
$data->{'asin'} = $item->{'ASIN'};
$data->{'url'} = $item->{'DetailPageURL'};
if (ref $item->{'MediumImage'} && $item->{'MediumImage'}->{'URL'}) {
	$data->{'image'} = join(',',$item->{'SmallImage'}->{'URL'},$item->{'MediumImage'}->{'URL'},((ref $item->{'LargeImage'} && $item->{'LargeImage'}->{'URL'}) ? $item->{'LargeImage'}->{'URL'} : ''));
	$data->{'width'} = join(',',$item->{'SmallImage'}->{'Width'}->{'value'},$item->{'MediumImage'}->{'Width'}->{'value'},((ref $item->{'LargeImage'} && $item->{'LargeImage'}->{'Width'}->{'value'}) ? $item->{'LargeImage'}->{'Width'}->{'value'} : ''));
	$data->{'height'} = join(',',$item->{'SmallImage'}->{'Height'}->{'value'},$item->{'MediumImage'}->{'Height'}->{'value'},((ref $item->{'LargeImage'} && $item->{'LargeImage'}->{'Height'}->{'value'}) ? $item->{'LargeImage'}->{'Height'}->{'value'} : ''));
}
$data->{'title'} = $item->{'ItemAttributes'}->{'Title'};
$data->{'manufacturer'} = $item->{'ItemAttributes'}->{'Manufacturer'} if $item->{'ItemAttributes'}->{'Manufacturer'};
$data->{'price'} = $item->{'ItemAttributes'}->{'ListPrice'}->{'FormattedPrice'} if $item->{'ItemAttributes'}->{'ListPrice'}->{'FormattedPrice'};
if ($item->{'ItemAttributes'}->{'Creator'}) {
	$data->{'creator'} = '';
	$this->scalar_to_array(\$item->{'ItemAttributes'}->{'Creator'});
	foreach my $creator (@{$item->{'ItemAttributes'}->{'Creator'}}) {
		$data->{'creator'} .= (($data->{'creator'}) ? ';' : '') . $creator->{'Role'} . ':' . $creator->{'value'};
	}
}
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
my($this,$str,$path,$c,$n) = @_;
return $this->field_tag('') if !defined $str || $str eq '';
my(%data);
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
return (%data && defined $data{'asin'} && $data{'asin'} ne '') ? $this->field_tag($this->data_tag_from_ref(\%data) . $this->amazon_link(\%data)) : $this->field_tag('');
}

sub format_for_mail {
my($this,$str) = @_;
$str = $this->format_for_text($str);
return ($str) ? '[' . $this->name . "]\x0A" . $str . "\x0A\x0A" : '';
}

sub format_for_text {
my($this,$str) = @_;
return '' if !defined $str || $str eq '';
my(%data);
%data = (ref $str eq 'HASH') ? (defined $$str{'str'}) ? $this->elements($$str{'str'}) : %$str : $this->elements($str);
if (%data && defined $data{'asin'} && $data{'asin'} ne '') {
	$str = $data{'title'} . "\x0A" . $data{'url'};
} else {
	return '';
}
}

sub amazon_link ($$;$) {
my($this,$data,$search_flag) = @_;
return '' if !ref $data || !$data->{'asin'} || !$data->{'title'};
my $image_size;
my $html = '<div class="amazon-item">';
my $url = $data->{'url'};
$url =~ s/\%253FSubscriptionId=$env::amazon_access_key//g;
if ($search_flag) {
	$image_size = 'medium';
	$html .= '<a href="JavaScript:cmonos.form.setASIN(\'' . $data->{'asin'} . '\',\'' . $this->escape($this->amazon_link($data)) . '\')" title="この商品にする">';
} else {
	$image_size = $this->{'image'};
	$html .= '<a href="' . $url . '"' . (($this->{'openNewWindow'}) ? ' target="_blank"' : '') . ' title="' . $data->{'title'} . '">';
}
if ($image_size eq 'disabled') {
	$html .= $data->{'title'};
} else {
	my($src,$width,$height);
	if (!$data->{'image'}) {
		($src,$width,$height) = ($image_size eq 'large') ? ($AmazonItem::no_image_gif_large,$AmazonItem::no_image_gif_large_width,$AmazonItem::no_image_gif_large_height) : ($AmazonItem::no_image_gif_small,$AmazonItem::no_image_gif_small_width,$AmazonItem::no_image_gif_small_height);
	} else {
		my($filter,@image,@width,@height);
		@image = split(/,/,$data->{'image'});
		@width = split(/,/,$data->{'width'});
		@height = split(/,/,$data->{'height'});
		$src = $image[1];
		if ($image_size eq 'large' && $width[2]) {
			$src = $image[2];
		} elsif ($image_size eq 'small') {
			$src = $image[0];
		}
		$filter .= ($this->{'dropshadow'} eq 'L') ? '_PB' : '_PC' if $this->{'dropshadow'};
		$filter .= (($this->{'rotation'} eq 'CCW') ? '_PU' : '_PV') . $this->{'deg'} if $this->{'rotation'} && $this->{'deg'};
		$filter .= '_SH' . $this->{'sharpen'} if $this->{'sharpen'};
		$filter .= '_BL' . $this->{'blur'} if $this->{'blur'};
		if ($search_flag) {
			$filter .= '_SL175';
		} else {
			$filter .= '_SX' . $this->{'maxwidth'} if $this->{'maxwidth'};
			$filter .= '_SY' . $this->{'maxheight'} if $this->{'maxheight'};
		}
		if ($filter) {
			$filter .= '_';
			$src =~ s/(\.[0-9a-zA-Z_]+)$/.$filter$1/ unless $src =~ s/\._?([0-9a-zA-Z_]+\.[0-9a-zA-Z_]+)$/.$filter$1/;
		} else {
			if ($image_size eq 'large' && $width[2]) {
				($width,$height) = ($width[2],$height[2]);
			} elsif ($image_size eq 'small') {
				($width,$height) = ($width[0],$height[0]);
			} else {
				($width,$height) = ($width[1],$height[1]);
			}
		}
	}
	$html .= '<img src="' . $src . '"' . (($width) ? ' width="' . $width . '"' : '') . (($height) ? ' height="' . $height . '"' : '') . ' border="0" alt="' . $data->{'title'} . '" />';
}
$html .= '</a><div><dl>';
if ($search_flag) {
	$html .= '<dd class="amazon-item-title"><a href="' . $url . '" target="_blank" title="新しいウィンドウで商品詳細ページを開く">' . $data->{'title'} . '</a></dd>';
	$html .= '<dt>ASIN</dt><dd>' . $data->{'asin'} . '</dd>';
} else {
	$html .= '<dd class="amazon-item-title">' . $data->{'title'} . '</dd>';
}
$html .= '<dt>参考価格</dt><dd class="amazon-item-price">' . (($data->{'price'}) ? $data->{'price'} : 'オープンプライス') . '</dd>';
if ($data->{'creator'}) {
	while ($data->{'creator'} =~ /\G(.*?):(.*?)(;|$)/g) {
		my($role,$name) = ($1,$2);
		$html .= '<dt>' . $this->escape($role) . '</dt><dd>' . $this->escape($name) . '</dd>';		
	}
}
$html .= '<dd class="amazon-item-manufacturer">' . $this->escape($this->{'manufacturer'}) . '</dd>' if $this->{'manufacturer'};
$html .= '</dl></div></div>';
return $html;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
my($this,$html_disabled) = @_;

#名前
my $name = 'data:' . $this->{'id'};

$this->print_field_info_form($name);

print '<fieldset>';
print '<legend><label for="' . $name . '_associatesId">アソシエイトID</label></legend>';
print '<input type="text" size="16" name="' . $name . '_associatesId" id="' . $name . '_associatesId" value="' . $this->escape($this->{'associatesId'}) . '" />';
print '</fieldset>';

print '<fieldset>';
print '<legend>リンク設定</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_openNewWindow" value="1"' . (($this->{'openNewWindow'}) ? ' checked="checked"' : '') . ' /> 商品詳細ページを新しいウィンドウで開く</label></li>';
print '</ol>';
print '</fieldset>';

print '<fieldset>';
print '<legend>商品検索画面</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="checkbox" name="' . $name . '_refererCheck" value="1"' . (($this->{'refererCheck'}) ? ' checked="checked"' : '') . ' /> この CGI から開いたかどうかリンク元をチェックする</label></li>';
print '</ol>';
print '</fieldset>';

print '<fieldset>';
print '<legend>商品画像設定</legend>';
print '<fieldset>';
print '<legend>画像サイズ</legend>';
print '<ol class="checkbox">';
print '<li><label><input type="radio" name="' . $name . '_image" value="large"' . (($this->{'image'} eq 'large') ? ' checked="checked"' : '') . ' /> 大 (300-400px角)</label></li>';
print '<li><label><input type="radio" name="' . $name . '_image" value="medium"' . (($this->{'image'} eq 'medium') ? ' checked="checked"' : '') . ' /> 中 (120-160px角)</label></li>';
print '<li><label><input type="radio" name="' . $name . '_image" value="small"' . (($this->{'image'} eq 'small') ? ' checked="checked"' : '') . ' /> 小 (50-70px角)</label></li>';
print '<li><label><input type="radio" name="' . $name . '_image" value="disabled"' . (($this->{'image'} eq 'disabled') ? ' checked="checked"' : '') . ' /> 画像なし</label></li>';
print '</ol>';
print '</fieldset>';
print '<fieldset>';
print '<legend>エフェクト(公開されていない機能を利用します)</legend>';
print '<table class="field-table">';
print '<tbody>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_dropshadow">ドロップシャドウ</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_dropshadow','','',$this->{'dropshadow'},
	''		=>		'',
	'R'		=>		'右下',
	'L'		=>		'左下'
);
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_rotation">回転</label></td>';
print '<td class="field">';
print $this->mk_select_menu(
	$name . '_rotation','','',$this->{'rotation'},
	''			=>		'',
	'CW'		=>		'時計回り',
	'CCW'		=>		'反時計回り'
);
print '<input type="text" size="3" name="' . $name . '_deg" value="' . $this->escape($this->{'deg'}) . '" />&deg; (0-180&deg;)';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_sharpen">シャープネス</label></td>';
print '<td class="field">';
print '<input type="text" size="2" name="' . $name . '_sharpen" id="' . $name . '_sharpen" value="' . $this->escape($this->{'sharpen'}) . '" /> (0-99)';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_blur">ぼかし</label></td>';
print '<td class="field">';
print '<input type="text" size="2" name="' . $name . '_blur" id="' . $name . '_blur" value="' . $this->escape($this->{'blur'}) . '" /> (0-9)';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_maxwidth">最大幅</label></td>';
print '<td class="field">';
print '<input type="text" size="2" name="' . $name . '_maxwidth" id="' . $name . '_maxwidth" value="' . $this->escape($this->{'maxwidth'}) . '" /> px';
print '</td>';
print '</tr>';
print '<tr>';
print '<td class="field-name"><label for="' . $name . '_maxheight">最大高さ</label></td>';
print '<td class="field">';
print '<input type="text" size="2" name="' . $name . '_maxheight" id="' . $name . '_maxheight" value="' . $this->escape($this->{'maxheight'}) . '" /> px';
print '</td>';
print '</tr>';
print '</tbody></table>';
print '</fieldset>';
print '</fieldset>';

$this->print_setting_save_button;
return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
my $this = shift;
my $is_valid = 1;
$main::data{$this->{'id'} . '_associatesId'} = $this->z_to_h($main::data{$this->{'id'} . '_associatesId'}) if $main::data{$this->{'id'} . '_associatesId'};
if ($main::data{$this->{'id'} . '_associatesId'} ne '' && $main::data{$this->{'id'} . '_associatesId'} =~ /[^0-9a-zA-Z_\-]/) {
	push(@{$cgi::action->{'dialog'}},'アソシエイトID が正しくありません。') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_associatesId'};
	$is_valid = 0;
}
if ($main::data{$this->{'id'} . '_deg'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_deg'})) {
	push(@{$cgi::action->{'dialog'}},'回転角度を更新できませんでした。半角数字にしてください。') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_deg'};
	$is_valid = 0;
} elsif ($main::data{$this->{'id'} . '_deg'} ne '' && $main::data{$this->{'id'} . '_deg'} > 180 && $main::data{$this->{'id'} . '_deg'} < 0) {
	push(@{$cgi::action->{'dialog'}},'回転角度を更新できませんでした。0&deg; 以上 180&deg; 以下にしてください。') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_deg'};
	$is_valid = 0;
}
if ($main::data{$this->{'id'} . '_sharpen'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_sharpen'})) {
	push(@{$cgi::action->{'dialog'}},'シャープネスを更新できませんでした。半角数字にしてください。') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_sharpen'};
	$is_valid = 0;
} elsif ($main::data{$this->{'id'} . '_sharpen'} ne '' && $main::data{$this->{'id'} . '_sharpen'} > 99 && $main::data{$this->{'id'} . '_sharpen'} < 0) {
	push(@{$cgi::action->{'dialog'}},'シャープネスを更新できませんでした。0 以上 99 以下にしてください。') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_sharpen'};
	$is_valid = 0;
}
if ($main::data{$this->{'id'} . '_blur'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_blur'})) {
	push(@{$cgi::action->{'dialog'}},'ぼかしのレベルを更新できませんでした。半角数字にしてください。') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_blur'};
	$is_valid = 0;
} elsif ($main::data{$this->{'id'} . '_blur'} ne '' && $main::data{$this->{'id'} . '_blur'} > 180 && $main::data{$this->{'id'} . '_blur'} < 0) {
	push(@{$cgi::action->{'dialog'}},'ぼかしのレベルを更新できませんでした。0 以上 9 以下にしてください。') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_blur'};
	$is_valid = 0;
}
if ($main::data{$this->{'id'} . '_maxwidth'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_maxwidth'})) {
	push(@{$cgi::action->{'dialog'}},'最大幅を更新できませんでした。半角数字にしてください。') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_maxwidth'};
	$is_valid = 0;
}
if ($main::data{$this->{'id'} . '_maxheight'} ne '' && $this->is_nan($main::data{$this->{'id'} . '_maxheight'})) {
	push(@{$cgi::action->{'dialog'}},'最大高さを更新できませんでした。半角数字にしてください。') if ref $cgi::action;
	delete $main::data{$this->{'id'} . '_maxheight'};
	$is_valid = 0;
}
$main::data{$this->{'id'} . '_refererCheck'} = '' if !$main::data{$this->{'id'} . '_refererCheck'};
$main::data{$this->{'id'} . '_openNewWindow'} = '' if !$main::data{$this->{'id'} . '_openNewWindow'};
$this->tag_fix(\$main::data{$this->{'id'} . '_description'}) if defined $main::data{$this->{'id'} . '_description'} && $main::data{$this->{'id'} . '_description'};
$this->tag_fix(\$main::data{$this->{'id'} . '_note'}) if defined $main::data{$this->{'id'} . '_note'} && $main::data{$this->{'id'} . '_note'};
return $is_valid;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
my $this = shift;
return 0;
}

######################################################################
sub editor_enabled ($) {
my $this = shift;
return 1;
}

sub is_secure_user_for_edit ($) {
my $this = shift;
if ($this->{'refererCheck'}) {
	my $my_url = $this->my_url;
	return ($ENV{'HTTP_REFERER'} && $ENV{'HTTP_REFERER'} =~ /^\Q$my_url\E/) ? 1 : 0;
} else {
	return 1;
}
}

sub set_user_generated_field_editor_page_settings ($) {
my $this = shift;
	$setting::page{'ugfieldeditor'}{'title'} = 'Amazon.co.jp 検索';
#	$setting::page{'ugfieldeditor'}{'text'} = '#000000'; 
#	$setting::page{'ugfieldeditor'}{'link'} = '#0000ff';
#	$setting::page{'ugfieldeditor'}{'alink'} = '#99ffff';
#	$setting::page{'ugfieldeditor'}{'vlink'} = '#000099';
#	$setting::page{'ugfieldeditor'}{'hover'} = '#00ffff';
#	$setting::page{'ugfieldeditor'}{'nodeco'} = 'no';
#	$setting::page{'ugfieldeditor'}{'bgcolor'} = '#ffffff';
	$setting::page{'ugfieldeditor'}{'bodyId'} = 'amazon-search';
	$setting::page{'ugfieldeditor'}{'cssFileName'} = 'amazon-search.css';
# 	$setting::page{'ugfieldeditor'}{'CSS'} = 'h1 { font-size: large; font-weight: bold; text-indent: 1em; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'h2 { font-size: medium; font-weight: bold; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'hr { border-width: 1 0 0 0; }';
# 	$setting::page{'ugfieldeditor'}{'background'} = '';
# 	$setting::page{'ugfieldeditor'}{'bgproperties'} = '';
# 	$setting::page{'ugfieldeditor'}{'topmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'leftmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'javascript'} = '';
# 	$setting::page{'ugfieldeditor'}{'header'} = '';
# 	$setting::page{'ugfieldeditor'}{'headerFileName'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImageAlign'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImage'} = '';
# 	$setting::page{'ugfieldeditor'}{'align'} = '';
# 	$setting::page{'ugfieldeditor'}{'width'} = '';
# 	$setting::page{'ugfieldeditor'}{'deco'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleText'} = '';
return 1;
}

sub print_user_generated_field_editor ($) {
my $this = shift;
my $hash;
$main::keywords = ($main::keywords) ? $this->z_to_h($main::keywords) : '';
$main::keywords =~ s/[\x09\x0A\x0C\x0D\x20]+/ /g;
$main::keywords =~ s/^[\x09\x0A\x0C\x0D\x20]+//;
if ($main::keywords) {
	$main::index = 'Blended' if !$main::index || $main::index =~ /[^0-9a-zA-Z_]/;
	$main::page = 1 if !$main::page || $main::page =~ /[^0-9]/;
	require CMONOS::CGI_Lib::HTTP_Client;
	my $res = HTTP_Client->new->request(
		'POST'	=>	$this->amazon_api_url(
			{
				'Operation'		=>	'ItemSearch',
				'SearchIndex'	=>	$main::index,
				'Keywords'		=>	$main::keywords,
				'ItemPage'		=>	$main::page
			}
		)
	);
	if ($res->is_success) {
		$hash = $res->hash('utf8');
		if ($hash->{'ItemSearchResponse'}->{'Items'}->{'Request'}->{'Errors'}) {
			if (ref $cgi::action) {
				$this->scalar_to_array(\$hash->{'ItemSearchResponse'}->{'Items'}->{'Request'}->{'Errors'}->{'Error'});
				foreach my $error (@{$hash->{'ItemSearchResponse'}->{'Items'}->{'Request'}->{'Errors'}->{'Error'}}) {
					push(@{$cgi::action->{'dialog'}},$error->{'Message'}) if $error->{'Message'};
				}
			}
			undef $hash;
		} elsif (!$hash->{'ItemSearchResponse'}->{'Items'}->{'Item'}) {
			push(@{$cgi::action->{'dialog'}},'Amazon から正常な応答がありませんでした。');
			undef $hash;
		}
	} else {
		push(@{$cgi::action->{'dialog'}},'Amazon に接続できませんでした。');
	}
}
if (ref $hash) {
my $javascript = <<SCRIPT;
cmonos.form.setASIN = function (asin,sample) {
	if (opener && opener.document.getElementById('data:$main::id:asin')) {
		opener.document.getElementById('data:$main::id:asin').value = asin;
		cmonos.element.item(opener.document.getElementById('data:$main::id:asin')).removeClassName('invalid-field');
		opener.document.getElementById('amazon-sample-$main::id').innerHTML = sample;
	} else if (confirm("呼び出し元フォームがみつかりません。このウィンドウを閉じますか？")) {
		window.close();
	}
};
SCRIPT
	$cgi::action->set_javascript($javascript);
}
$cgi::action->print_page_header('ugfieldeditor');
print $this->form_start(
	'key'		=>	'ugfieldeditor',
	'name'		=>	'input',
	'method'	=>	'post',
	'onsubmit'	=>	'return cmonos.form.item(this).isNotSubmitted()',
	'required'	=>	['m','k','id','c','mod','p']	
);
print '<select name="index">';
for (my $i=0; $i < @AmazonItem::search_index; $i+=2) {
	print '<option value="' . $AmazonItem::search_index[$i] . '"' . (($main::index && $main::index eq $AmazonItem::search_index[$i]) ? ' selected="selected"' : '') . '>' . $AmazonItem::search_index[$i+1] . '</option>';
}
print '</select>';
print '<input type="search" placeholder="amazon.co.jp を検索" results="5" autosave="amazon-item-search" size="30" name="keywords" value="' . $this->escape($main::keywords) . '" />';
print '<input type="submit" value="検索" />';
print '</form>';
if ($main::keywords) {
	print '<div class="search-result">';
	if (ref $hash) {
		my $totalpages = ($hash->{'ItemSearchResponse'}->{'Items'}->{'TotalPages'}) ? $hash->{'ItemSearchResponse'}->{'Items'}->{'TotalPages'} : 1;
		$this->scalar_to_array(\$hash->{'ItemSearchResponse'}->{'Items'}->{'Item'});
		foreach my $item (@{$hash->{'ItemSearchResponse'}->{'Items'}->{'Item'}}) {
			my %data = ();
			$this->set_item_data(\%data,$item);
			print $this->amazon_link(\%data,1);
		}
		print '<div class="search-navi">';
		if ($totalpages > 1) {
			my $url = $this->escape('./start.cgi' . $this->get_query_for_editor . $this->add_query('url',{'index' => $main::index,'keywords' => $main::keywords}) . '&page=');
			print '<a href="' . $url . ($main::page - 1) . '">&lt; 前のページ</a>' if $main::page > 1;
			foreach my $p (1..$totalpages) {
				if ($p == $main::page) {
					print ' <strong>' . $p . '</strong>';
				} else {
					print ' <a href="' . $url . $p . '">' . $p . '</a>';
				}
			}
			print ' <a href="' . $url . ($main::page + 1) . '">次のページ &gt;</a>' if $main::page < $totalpages;
		} else {
			print '<strong>1</strong>';
		}
		print '</div>';
	} else {
		print '<p>"' . $this->escape($main::keywords) . '"に完全に一致する結果がありませんでした。</p>';
	}
	print '</div>';
}
$cgi::action->print_page_footer('ugfieldeditor');
return 1;
}

sub user_generated_field_edit ($) {
my $this = shift;
return 1;
}

sub get_query_for_editor ($;$$$) {
my($this,$c) = @_;
return '?m=UserGeneratedFieldEditor&k=ugfieldeditor&id=' . $this->{'id'}
	 . (($default::subdivided && defined $main::c) ? '&c=' . $main::c : '')
	 . (($main::m && $main::m !~ /[^0-9a-zA-Z_]/ && $main::m ne 'UserGeneratedFieldEditor') ? '&mod=' . $main::m : ($main::mod && $main::mod !~ /[^0-9a-zA-Z_]/ && $main::mod ne 'UserGeneratedFieldEditor') ? '&mod=' . $main::mod : '')
	 . (($main::p && $main::p !~ /[^0-9a-zA-Z_]/) ? '&p=' . $main::p : '');
}

######################################################################
#sub import {
BEGIN {
	Field::class_register('webapi_amazon','AmazonItem','Amazon 商品リンク') if $env::amazon_access_key;
}

1;
